---
title: Constraint validation
slug: Web/Guide/HTML/HTML5/Constraint_validation
tags:
  - CSS
  - Guide
  - HTML5
  - NeedsContent
  - Selectors
---
<p>The creation of web forms has always been a complex task. While marking up the form itself is easy, checking whether each field has a valid and coherent value is more difficult, and informing the user about the problem may become a headache.<a href="/en-US/docs/Web/Guide/HTML/HTML5"> HTML5</a> introduced new mechanisms for forms: it added new semantic types for the {{ HTMLElement("input") }} element and <em>constraint validation</em> to ease the work of checking the form content on the client side. Basic, usual constraints can be checked, without the need for JavaScript, by setting new attributes; more complex constraints can be tested using the <a href="/en-US/docs/Web/API/Constraint_validation">Constraint validation API</a>.</p>

<p>For a basic introduction to these concepts, with examples, see the <a href="/en-US/docs/Learn/HTML/Forms/Form_validation">Form validation tutorial</a>.</p>

<div class="note"><strong>Note:</strong> HTML5 Constraint validation doesn't remove the need for validation on the <em>server side</em>. Even though far fewer invalid form requests are to be expected, invalid ones can still be sent by non-compliant browsers (for instance, browsers without HTML5 and without JavaScript) or by bad people trying to trick your web application. Therefore, like with HTML4, you need to also validate input constraints on the server side, in a way that is consistent with what is done on the client side.</div>

<h2 id="Intrinsic_and_basic_constraints">Intrinsic and basic constraints</h2>

<p>In HTML5, basic constraints are declared in two ways:</p>

<ul>
 <li>By choosing the most semantically appropriate value for the {{ htmlattrxref("type", "input") }} attribute of the {{ HTMLElement("input") }} element, e.g., choosing the <code>email</code> type automatically creates a constraint that checks whether the value is a valid e-mail address.</li>
 <li>By setting values on validation-related attributes, allowing basic constraints to be described in a simple way, without the need for JavaScript.</li>
</ul>

<h3 id="Semantic_input_types">Semantic input types</h3>

<p>The intrinsic constraints for the {{ htmlattrxref("type", "input") }} attribute are:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Input type</th>
   <th scope="col">Constraint description</th>
   <th scope="col">Associated violation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code><a href="/en-US/docs/Web/HTML/Element/input/url">&lt;input type="URL"&gt;</a></code></td>
   <td>The value must be an absolute <a href="/en-US/docs/Learn/Common_questions/What_is_a_URL">URL</a>, as defined in the <a href="https://url.spec.whatwg.org/">URL Living Standard</a>.</td>
   <td><strong><a href="/en-US/docs/Web/API/ValidityState/typeMismatch">TypeMismatch</a> </strong>constraint violation</td>
  </tr>
  <tr>
   <td><code><a href="/en-US/docs/Web/HTML/Element/input/email">&lt;input type="email"&gt;</a></code></td>
   <td>The value must be a syntactically valid email address, which generally has the format <code><em>username</em>@<em>hostname</em>.<em>tld</em></code>.</td>
   <td><strong><a href="/en-US/docs/Web/API/ValidityState/typeMismatch">TypeMismatch</a> </strong>constraint violation</td>
  </tr>
 </tbody>
</table>

<p>For both of these input types, if the {{ htmlattrxref("multiple", "input") }} attribute is set, several values can be set, as a comma-separated list, for this input. If any of these do not satisfy the condition described here, the <strong>Type mismatch </strong>constraint violation is triggered.</p>

<p>Note that most input types don't have intrinsic constraints, as some are barred from constraint validation or have a sanitization algorithm transforming incorrect values to a correct default.</p>

<h3 id="Validation-related_attributes">Validation-related attributes</h3>

<p>In addition to the <code>type</code> attribute described above, the following attributes are used to describe basic constraints:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Attribute</th>
   <th scope="col">Input types supporting the attribute</th>
   <th scope="col">Possible values</th>
   <th scope="col">Constraint description</th>
   <th scope="col">Associated violation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code><a href="/en-US/docs/Web/HTML/Attributes/pattern">pattern</a></code></td>
   <td><code>text</code>, <code>search</code>, <code>url</code>, <code>tel</code>, <code>email</code>, <code>password</code></td>
   <td>A <a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">JavaScript regular expression</a> (compiled with the <a class="external" href="http://www.ecma-international.org/publications/standards/Ecma-262.htm">ECMAScript 5</a> <code>global</code>, <code>ignoreCase</code>, and <code>multiline</code> flags <em>disabled)</em></td>
   <td>The value must match the pattern.</td>
   <td><code><strong><a href="/en-US/docs/Web/API/ValidityState/patternMismatch">patternMismatch</a></strong></code> constraint violation</td>
  </tr>
  <tr>
   <td rowspan="3"><code><a href="/en-US/docs/Web/HTML/Attributes/min">min</a></code></td>
   <td><code>range</code>, <code>number</code></td>
   <td>A valid number</td>
   <td rowspan="3">The value must be greater than or equal to the value.</td>
   <td rowspan="3"><strong><code><a href="/en-US/docs/Web/API/ValidityState/rangeUnderflow">rangeUnderflow</a></code></strong> constraint violation</td>
  </tr>
  <tr>
   <td><code>date</code>, <code>month</code>, <code>week</code></td>
   <td>A valid date</td>
  </tr>
  <tr>
   <td><code>datetime</code>, <code>datetime-local</code>, <code>time</code></td>
   <td>A valid date and time</td>
  </tr>
  <tr>
   <td rowspan="3"><code><a href="/en-US/docs/Web/HTML/Attributes/max">max</a></code></td>
   <td><code>range</code>, <code>number</code></td>
   <td>A valid number</td>
   <td rowspan="3">The value must be less than or equal to the value</td>
   <td rowspan="3"><strong><code><a href="/en-US/docs/Web/API/ValidityState/rangeOverflow">rangeOverflow</a></code></strong> constraint violation</td>
  </tr>
  <tr>
   <td><code>date</code>, <code>month</code>, <code>week</code></td>
   <td>A valid date</td>
  </tr>
  <tr>
   <td><code>datetime</code>, <code>datetime-local</code>, <code>time</code></td>
   <td>A valid date and time</td>
  </tr>
  <tr>
   <td><code><a href="/en-US/docs/Web/HTML/Attributes/required">required</a></code></td>
   <td><code>text</code>, <code>search</code>, <code>url</code>, <code>tel</code>, <code>email</code>, <code>password</code>, <code>date</code>, <code>datetime</code>, <code>datetime-local</code>, <code>month</code>, <code>week</code>, <code>time</code>, <code>number</code>, <code>checkbox</code>, <code>radio</code>, <code>file</code>; also on the {{ HTMLElement("select") }} and {{ HTMLElement("textarea") }} elements</td>
   <td><em>none</em> as it is a Boolean attribute: its presence means <em>true</em>, its absence means <em>false</em></td>
   <td>There must be a value (if set).</td>
   <td><strong><code><a href="/en-US/docs/Web/API/ValidityState/valueMissing">valueMissing</a></code></strong> constraint violation</td>
  </tr>
  <tr>
   <td rowspan="5"><code><a href="/en-US/docs/Web/HTML/Attributes/step">step</a></code></td>
   <td><code>date</code></td>
   <td>An integer number of days</td>
   <td rowspan="5">Unless the step is set to the <code>any</code> literal, the value must be <strong>min</strong> + an integral multiple of the step.</td>
   <td rowspan="5"><strong><code><a href="/en-US/docs/Web/API/ValidityState/stepMismatch">stepMismatch</a></code> </strong>constraint violation</td>
  </tr>
  <tr>
   <td><code>month</code></td>
   <td>An integer number of months</td>
  </tr>
  <tr>
   <td><code>week</code></td>
   <td>An integer number of weeks</td>
  </tr>
  <tr>
   <td><code>datetime</code>, <code>datetime-local</code>, <code>time</code></td>
   <td>An integer number of seconds</td>
  </tr>
  <tr>
   <td><code>range</code>, <code>number</code></td>
   <td>An integer</td>
  </tr>
  <tr>
   <td><code><a href="/en-US/docs/Web/HTML/Attributes/minlength">minlength</a></code></td>
   <td><code>text</code>, <code>search</code>, <code>url</code>, <code>tel</code>, <code>email</code>, <code>password</code>; also on the {{ HTMLElement("textarea") }} element</td>
   <td>An integer length</td>
   <td>The number of characters (code points) must not be less than the value of the attribute, if non-empty. All newlines are normalized to a single character (as opposed to CRLF pairs) for {{ HTMLElement("textarea") }}.</td>
   <td><strong><code><a href="/en-US/docs/Web/API/ValidityState/tooShort">tooShort</a></code></strong> constraint violation</td>
  </tr>
  <tr>
   <td><code><a href="/en-US/docs/Web/HTML/Attributes/maxlength">maxlength</a></code></td>
   <td><code>text</code>, <code>search</code>, <code>url</code>, <code>tel</code>, <code>email</code>, <code>password</code>; also on the {{ HTMLElement("textarea") }} element</td>
   <td>An integer length</td>
   <td>The number of characters (code points) must not exceed the value of the attribute.</td>
   <td><strong><code><a href="/en-US/docs/Web/API/ValidityState/tooLong">tooLong</a></code></strong> constraint violation</td>
  </tr>
 </tbody>
</table>

<h2 id="Constraint_validation_process">Constraint validation process</h2>

<p>Constraint validation is done through the Constraint Validation API either on a single form element or at the form level, on the {{ HTMLElement("form") }} element itself. The constraint validation is done in the following ways:</p>

<ul>
 <li>By a call to the <code>checkValidity()</code> or <code>reportValidity()</code> method of a form-associated DOM interface, (<code><a href="/en-US/docs/Web/API/HTMLInputElement">HTMLInputElement</a></code>, <code><a href="/en-US/docs/Web/API/HTMLSelectElement">HTMLSelectElement</a></code>, <code><a href="/en-US/docs/Web/API/HTMLButtonElement">HTMLButtonElement</a></code>, <code><a href="/en-US/docs/Web/API/HTMLOutputElement">HTMLOutputElement</a></code> or <code><a href="/en-US/docs/Web/API/HTMLTextAreaElement">HTMLTextAreaElement</a></code>), which evaluates the constraints only on this element, allowing a script to get this information. The <code>checkValidity()</code> method returns a Boolean indicating whether the element's value passes its constraints. (This is typically done by the user-agent when determining which of the CSS pseudo-classes, {{ Cssxref(":valid") }} or {{ Cssxref(":invalid") }}, applies.) In contrast, the <code>reportValidity()</code> method reports any constraint failures to the user.</li>
 <li>By a call to the <code>checkValidity()</code> or <code>reportValidity()</code> method on the <code><a href="/en-US/docs/Web/API/HTMLFormElement">HTMLFormElement</a></code> interface.</li>
 <li>By submitting the form itself.</li>
</ul>

<p>Calling <code>checkValidity()</code> is called <em>statically</em> validating the constraints, while calling <code>reportValidity()</code> or submitting the form is called <em>interactively</em> validating the constraints.</p>

<div class="note"><strong>Note: </strong>

<ul>
 <li>If the {{ htmlattrxref("novalidate", "form") }} attribute is set on the {{ HTMLElement("form") }} element, interactive validation of the constraints doesn't happen.</li>
 <li>Calling the <code>submit()</code> method on the <code><a href="/en/DOM/HTMLFormElement">HTMLFormElement</a></code> interface doesn't trigger a constraint validation. In other words, this method sends the form data to the server even if doesn't satisfy the constraints. Call the <code>click()</code> method on a submit button instead.</li>
</ul>
</div>

<h2 id="Complex_constraints_using_the_Constraint_Validation_API">Complex constraints using the Constraint Validation API</h2>

<p>Using JavaScript and the Constraint API, it is possible to implement more complex constraints, for example, constraints combining several fields, or constraints involving complex calculations.</p>

<p>Basically, the idea is to trigger JavaScript on some form field event (like <strong>onchange</strong>) to calculate whether the constraint is violated, and then to use the method <code><em>field</em>.setCustomValidity()</code> to set the result of the validation: an empty string means the constraint is satisfied, and any other string means there is an error and this string is the error message to display to the user.</p>

<h3 id="Constraint_combining_several_fields_Postal_code_validation">Constraint combining several fields: Postal code validation</h3>

<p>The postal code format varies from one country to another. Not only do most countries allow an optional prefix with the country code (like <code>D-</code> in Germany, <code>F- </code> in France or Switzerland), but some countries have postal codes with only a fixed number of digits; others, like the UK, have more complex structures, allowing letters at some specific positions.</p>

<div class="note">
<p><strong>Note:</strong> This is not a comprehensive postal code validation library, but rather a demonstration of the key concepts.</p>
</div>

<p>As an example, we will add a script checking the constraint validation for this simple form:</p>

<pre class="brush: html">&lt;form&gt;
    &lt;label for="ZIP"&gt;ZIP : &lt;/label&gt;
    &lt;input type="text" id="ZIP"&gt;
    &lt;label for="Country"&gt;Country : &lt;/label&gt;
    &lt;select id="Country"&gt;
      &lt;option value="ch"&gt;Switzerland&lt;/option&gt;
      &lt;option value="fr"&gt;France&lt;/option&gt;
      &lt;option value="de"&gt;Germany&lt;/option&gt;
      &lt;option value="nl"&gt;The Netherlands&lt;/option&gt;
    &lt;/select&gt;
    &lt;input type="submit" value="Validate"&gt;
&lt;/form&gt;</pre>

<p>This displays the following form:</p>

<p>{{EmbedLiveSample("Constraint_combining_several_fields_Postal_code_validation")}}</p>

<p>First, we write a function checking the constraint itself:</p>

<pre class="brush: js">function checkZIP() {
  // For each country, defines the pattern that the ZIP has to follow
  var constraints = {
    ch : [ '^(CH-)?\\d{4}$', "Switzerland ZIPs must have exactly 4 digits: e.g. CH-1950 or 1950" ],
    fr : [ '^(F-)?\\d{5}$' , "France ZIPs must have exactly 5 digits: e.g. F-75012 or 75012" ],
    de : [ '^(D-)?\\d{5}$' , "Germany ZIPs must have exactly 5 digits: e.g. D-12345 or 12345" ],
    nl : [ '^(NL-)?\\d{4}\\s*([A-RT-Z][A-Z]|S[BCE-RT-Z])$',
                    "Nederland ZIPs must have exactly 4 digits, followed by 2 letters except SA, SD and SS" ]
  };

  // Read the country id
  var country = document.getElementById("Country").value;

  // Get the NPA field
  var ZIPField = document.getElementById("ZIP");

  // Build the constraint checker
  var constraint = new RegExp(constraints[country][0], "");
    console.log(constraint);

  // Check it!
  if (constraint.test(ZIPField.value)) {
    // The ZIP follows the constraint, we use the ConstraintAPI to tell it
    ZIPField.setCustomValidity("");
  }
  else {
    // The ZIP doesn't follow the constraint, we use the ConstraintAPI to
    // give a message about the format required for this country
    ZIPField.setCustomValidity(constraints[country][1]);
  }
}
</pre>

<p>Then we link it to the <strong>onchange</strong> event for the {{ HTMLElement("select") }} and the <strong>oninput</strong> event for the {{ HTMLElement("input") }}:</p>

<pre class="brush: js">window.onload = function () {
    document.getElementById("Country").onchange = checkZIP;
    document.getElementById("ZIP").oninput = checkZIP;
}</pre>

<p>You can see a <a href="/@api/deki/files/4744/=constraint.html">live example</a> of the postal code validation.</p>

<h3 id="Limiting_the_size_of_a_file_before_its_upload">Limiting the size of a file before its upload</h3>

<p>Another common constraint is to limit the size of a file to be uploaded. Checking this on the client side before the file is transmitted to the server requires combining the Constraint Validation API, and especially the <code>field.setCustomValidity()</code> method, with another JavaScript API, here the File API.</p>

<p>Here is the HTML part:</p>

<pre class="brush: html">&lt;label for="FS"&gt;Select a file smaller than 75 kB : &lt;/label&gt;
&lt;input type="file" id="FS"&gt;</pre>

<p>This displays:</p>

<p>{{EmbedLiveSample("Limiting_the_size_of_a_file_before_its_upload")}}</p>

<p>The JavaScript reads the file selected, uses the <code>File.size()</code> method to get its size, compares it to the (hard coded) limit, and calls the Constraint API to inform the browser if there is a violation:</p>

<pre class="brush: js">function checkFileSize() {
  var FS = document.getElementById("FS");
  var files = FS.files;

  // If there is (at least) one file selected
  if (files.length &gt; 0) {
     if (files[0].size &gt; 75 * 1024) { // Check the constraint
       FS.setCustomValidity("The selected file must not be larger than 75 kB");
       return;
     }
  }
  // No custom constraint violation
  FS.setCustomValidity("");
}</pre>

<p>Finally we hook the method with the correct event:</p>

<pre class="brush: js">window.onload = function () {
  document.getElementById("FS").onchange = checkFileSize;
}</pre>

<p>You can see a <a href="/@api/deki/files/4745/=fileconstraint.html">live example</a> of the File size constraint validation.</p>

<h2 id="Visual_styling_of_constraint_validation">Visual styling of constraint validation</h2>

<p>Apart from setting constraints, web developers want to control what messages are displayed to the users and how they are styled.</p>

<h3 id="Controlling_the_look_of_elements">Controlling the look of elements</h3>

<p>The look of elements can be controlled via CSS pseudo-classes.</p>

<h4 id="required_and_optional_CSS_pseudo-classes">:required and :optional CSS pseudo-classes</h4>

<p>The {{cssxref(':required')}} and {{cssxref(':optional')}} <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-classes</a> allow writing selectors that match form elements that have the {{ htmlattrxref("required") }} attribute, or that don't have it.</p>

<h4 id="placeholder-shown_CSS_pseudo-class">:placeholder-shown CSS pseudo-class</h4>

<p>See {{cssxref(':placeholder-shown')}}</p>

<h4 id="valid_invalid_CSS_pseudo-classes">:valid :invalid CSS pseudo-classes</h4>

<p>The {{cssxref(':valid')}} and {{cssxref(':invalid')}} <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-classes</a> are used to represent &lt;input&gt; elements whose content validates and fails to validate respectively according to the input's type setting. These classes allow the user to style valid or invalid form elements to make it easier to identify elements that are either formatted correctly or incorrectly.</p>

<h3 id="Controlling_the_text_of_constraint_violation">Controlling the text of constraint violation</h3>

<p>The following items can help with controlling the text of a constraint violation:</p>

<ul>
 <li><a href="/en-US/docs/Web/API/Constraint_validation#element.setCustomValidity(message)">element.setCustomValidity(message)</a> method on the following elements:

  <ul>
   <li>{{HTMLElement("fieldset")}}. Note: Setting a custom validity message on fieldset elements will not prevent form submission in most browsers.</li>
   <li>{{HTMLElement("input")}}</li>
   <li>{{HTMLElement("output")}}</li>
   <li>{{HTMLElement("select")}}</li>
   <li>Submit buttons (created with either a {{HTMLElement("button")}} element with the <code>submit</code> type, or an <code>input</code> element with the {{HTMLElement("input/submit", "submit")}} type. Other types of buttons do not participate in constraint validation.</li>
   <li>{{HTMLElement("textarea")}}</li>
  </ul>
 </li>
 <li>The <a href="/en-US/docs/Web/API/ValidityState"><code>ValidityState</code></a> interface describes the object returned by the <a href="/en-US/docs/Web/API/Constraint_validation#validity">validity</a> property of the element types listed above. It represents various ways that an entered value can be invalid. Together, they help explain why an element's value fails to validate, if it's not valid.</li>
</ul>
